unit Schatz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, Menus, Info, Regeln, ExtCtrls;

type
  TFeld=Array[0..9,0..9]of Integer;
  TSF = class(TForm)
    SpielFeld: TStringGrid;
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Verstecken: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Level: TMenuItem;
    Level1: TMenuItem;
    Level2: TMenuItem;
    Level3: TMenuItem;
    Level4: TMenuItem;
    Level5: TMenuItem;
    Level6: TMenuItem;
    StatusBar: TStatusBar;
    Uhr: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure LevelClick(Sender: TObject);
    procedure VersteckenClick(Sender: TObject);
    procedure SpielFeldMouseDown(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure SpielFeldDrawCell(Sender: TObject; ACol, ARow: Integer;
                                Rect: TRect; State: TGridDrawState);
    procedure SpielFeldMouseMove(Sender: TObject; Shift: TShiftState;
                                 X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState;X,Y:Integer);
    procedure BeendenClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure UhrTimer(Sender: TObject);
  private
    { Private-Deklarationen }
   Feld:TFeld;
   Schuss,Gefunden,Versuche:Integer;
   Schluss:Boolean;
   TruheBild,Maulwurf:TBitMap;
   // eigene Methoden
   procedure Entfernung(Col,Row:Integer);
   procedure Spielbewertung;
   function Erlaubt(x,y:Integer):Boolean;
  public
    { Public-Deklarationen }
  end;

var SF:TSF;

implementation

{$R *.dfm}
{$R+,Q+}

 const KeinSchatz=10;Truhe=20;SchatzGefunden=30;
       
 procedure TSF.FormCreate(Sender: TObject);
  var Rect:TGridRect;
  begin
   Rect.Left  :=-1;
   Rect.Top   :=-1;
   Rect.Right :=-1;
   Rect.Bottom:=-1;
   SpielFeld.Selection:=Rect; // blaue Feld wird gelscht
   Randomize; // Aktivierung des Zufallgenerators
   Versuche:=10; // fr Level Anfnger
   SpielFeld.Enabled:=False; // Spielfeld ist deaktiviert
   Verstecken.Enabled:=False; // Spiel ist deaktiviert, es mu erst ein Level gewhlt werden
   TruheBild:=TBitmap.Create; // Speicher wird reserviert
   TruheBild.LoadFromFile('Truhe.bmp'); // Bilddateien werden geladen
   TruheBild.Transparent:=True;
   Maulwurf:=TBitmap.Create;
   Maulwurf.LoadFromFile('Maulwurf.bmp');
   Maulwurf.Transparent:=True;
  end;

 procedure TSF.LevelClick(Sender: TObject);
  begin
   if Sender=Level1 then begin Versuche:=10;Level1.Checked:=True end;
   if Sender=Level2 then begin Versuche:=9;Level2.Checked:=True end;
   if Sender=Level3 then begin Versuche:=8;Level3.Checked:=True end;
   if Sender=Level4 then begin Versuche:=7;Level4.Checked:=True end;
   if Sender=Level5 then begin Versuche:=6;Level5.Checked:=True end;
   if Sender=Level6 then begin Versuche:=5;Level6.Checked:=True end;
   Caption:='Schatzsuche     '+IntToStr(Versuche)+' Versuche';
   Verstecken.Enabled:=True; // Spiel kann beginnen
  end;

 procedure TSF.VersteckenClick(Sender: TObject);
  var K,x,y:Integer;
  begin
   Caption:='Schatzsuche'; // neue berschrift im Formular
   for x:=0 to 9 do
    for y:=0 to 9 do Feld[x,y]:=0;
   SpielFeld.Repaint; // Spielfeld lschen
   for K:=1 to 4 do // Schtze verstecken
    begin
     repeat x:=random(10);y:=random(10) until Feld[x,y]=0;
     Feld[x,y]:=Truhe;
    end;
   Schuss:=0;Gefunden:=0;
   SpielFeld.Enabled:=True;
   Level.Enabled:=False;
   Verstecken.Enabled:=False;
   Schluss:=False;
  end;

 procedure TSF.Entfernung(Col,Row:Integer);
  var x,y:Integer;
      Entfernung:Extended;
      Zeile:String;
  begin
   Zeile:=' Entfernungen: ';
   for x:=0 to 9 do
    for y:=0 to 9 do
     if Feld[x,y]=Truhe then
      begin
       Entfernung:=sqrt(sqr(x-Col)+sqr(y-Row));
       Zeile:=Zeile+'('+Format('%0.2f',[Entfernung])+')  ';
      end;
   StatusBar.Panels[0].Text:=Zeile;
  end;

 function TSF.Erlaubt(x,y:Integer):Boolean;
  begin
   Erlaubt:=(x>=0) and (x<=9) and (y>=0) and (y<=9);
  end;

 procedure TSF.SpielFeldMouseMove(Sender: TObject; Shift: TShiftState;
                                  X,Y: Integer);
  var ACol,ARow,Inhalt:Integer;
  begin
   SpielFeld.MouseToCell(X,Y,ACol,ARow); // Maus Koordinaten in Gitter Koordinaten
   if not Erlaubt(ACol,ARow) then
    begin
     StatusBar.Panels[1].Text:=' Koordinaten: ';
     MessageDlg('Was willst Du auerhalb des Spielfeldes?!',mtError,[mbRetry],0);
     exit
    end;
   Inhalt:=Feld[ACol,ARow];
   if (Inhalt=SchatzGefunden) or (Inhalt=KeinSchatz) then Entfernung(ACol,ARow)
   else StatusBar.Panels[0].Text:=' Entfernungen:';
   StatusBar.Panels[1].Text:=' Koordinaten: '+'('+IntToStr(ACol)+','+IntToStr(ARow)+')';
  end;

 procedure TSF.UhrTimer(Sender: TObject);
  begin
   with Mouse.CursorPos do
    if (X<SF.Left) or (X>SF.Left+SF.Width) or
       (Y<SF.Top)  or (Y>SF.Top+SF.Height)  then
         StatusBar.Panels[1].Text:=' Koordinaten: ';
  end;

 procedure TSF.FormMouseMove(Sender:TObject;Shift:TShiftState;X,Y: Integer);
  begin
   StatusBar.Panels[1].Text:=' Koordinaten: '; // falls Maus auerhalb vom Spielfeld
  end;

 procedure TSF.Spielbewertung;
  var x,y:Integer;
  begin
   if gefunden=4 then // erfolgreiche Suche
    begin
     MessageDLG('Du bist ein guter Schatzjger!'+#13+'Du brauchtest nur '+
                IntToStr(Schuss)+' Versuche!',mtInformation,[mbOK],0);
     Caption:='Schatzsuche war erfolgreich!';
     Level.Enabled:=True;
     Verstecken.Enabled:=True;
     Schluss:=True
    end
   else if Versuche=Schuss then // letzter Versuch
    begin
     MessageDLG('Du bist ein VERSAGER!',mtInformation,[mbOK],0);
     for x:=0 to 9 do
      for y:=0 to 9 do
       if Feld[x,y]=Truhe then Feld[x,y]:=SchatzGefunden;
     SpielFeld.Repaint; // nicht gefundene Truhen werden angezeigt
     Level.Enabled:=True;
     Verstecken.Enabled:=True;
     Schluss:=True
    end
  end;

 procedure TSF.SpielFeldMouseDown(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  var ACol,ARow:Integer;
  begin
   if Schluss then
    Begin
     MessageDlg('Das Spiel ist schon zu Ende!',mtError,[mbOk],0);
     exit
    End;
   if not(Shift=[ssLeft]) then exit;
   SpielFeld.MouseToCell(X,Y,ACol,ARow);
   if (Feld[ACol,ARow]=SchatzGefunden) or (Feld[ACol,ARow]=KeinSchatz) then exit;
   inc(Schuss);
   if Feld[ACol,ARow]=0 then Feld[ACol,ARow]:=KeinSchatz
   else
    begin
     inc(Gefunden);
     Feld[ACol,ARow]:=SchatzGefunden; // Truhe gefunden
    end;
   SpielFeld.Repaint;
   Caption:='Schatzsuche     '+IntToStr(Versuche-Schuss)+' Versuch';
   if Versuche-Schuss<>1 then Caption:=Caption+'e';
   Entfernung(ACol,ARow);
   Spielbewertung;
  end;

 procedure TSF.SpielFeldDrawCell(Sender: TObject; ACol, ARow: Integer;
                                 Rect: TRect; State: TGridDrawState);
  var Inhalt:Integer;
  begin
   with SpielFeld.Canvas do
    begin
     Inhalt:=Feld[ACol,ARow];
     case Inhalt of
      KeinSchatz: Draw(Rect.Left,Rect.Top,Maulwurf);
      SchatzGefunden: Draw(Rect.Left,Rect.Top,TruheBild);
     end
    end
  end;

 procedure TSF.BeendenClick(Sender: TObject);
  begin close end;

 procedure TSF.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TSF.RegelnClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TSF.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Willst du das Programm beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Die Schatzsuche wird eingestellt!',mtWarning,[mbOk],0);
     CanClose:=True
    end
   else CanClose:=False
  end;

end.

